# HG changeset patch
# Node ID a74103355a4f
# Parent  276e97d2d581
diff --git a/finch/gntblist.c b/finch/gntblist.c
--- a/finch/gntblist.c
+++ b/finch/gntblist.c
@@ -1000,8 +1000,9 @@ chat_components_edit_ok(PurpleChat *chat
 			id = purple_request_field_get_id(field);
 			if (purple_request_field_get_field_type(field) == PURPLE_REQUEST_FIELD_INTEGER)
 				val = g_strdup_printf("%d", purple_request_field_int_get_value(field));
-			else
-				val = g_strdup(purple_request_field_string_get_value(field));
+			else {
+				val = g_strdup(purple_request_field_string_get_value(PURPLE_REQUEST_FIELD_STRING(field)));
+			}
 
 			if (!val) {
 				g_hash_table_remove(purple_chat_get_components(chat), id);
@@ -1040,8 +1041,10 @@ chat_components_edit(G_GNUC_UNUSED Purpl
 		} else {
 			field = purple_request_field_string_new(pce->identifier, pce->label,
 					g_hash_table_lookup(purple_chat_get_components(chat), pce->identifier), FALSE);
-			if (pce->secret)
-				purple_request_field_string_set_masked(field, TRUE);
+			if(pce->secret) {
+				purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+				                                       TRUE);
+			}
 		}
 
 		if (pce->required)
diff --git a/finch/gntrequest.c b/finch/gntrequest.c
--- a/finch/gntrequest.c
+++ b/finch/gntrequest.c
@@ -299,13 +299,15 @@ request_fields_cb(GntWidget *button, Pur
 				                                     "finch-ui-data");
 				gboolean value = gnt_check_box_get_checked(GNT_CHECK_BOX(check));
 				purple_request_field_bool_set_value(field, value);
-			}
-			else if (type == PURPLE_REQUEST_FIELD_STRING)
-			{
+			} else if(PURPLE_IS_REQUEST_FIELD_STRING(field)) {
 				GntWidget *entry = g_object_get_data(G_OBJECT(field),
 				                                     "finch-ui-data");
 				const char *text = gnt_entry_get_text(GNT_ENTRY(entry));
-				purple_request_field_string_set_value(field, (text && *text) ? text : NULL);
+				if(purple_strempty(text)) {
+					text = NULL;
+				}
+				purple_request_field_string_set_value(PURPLE_REQUEST_FIELD_STRING(field),
+				                                      text);
 			}
 			else if (type == PURPLE_REQUEST_FIELD_INTEGER)
 			{
@@ -424,11 +426,12 @@ create_boolean_field(PurpleRequestField 
 static GntWidget*
 create_string_field(PurpleRequestField *field, GntWidget **username)
 {
+	PurpleRequestFieldString *strfield = PURPLE_REQUEST_FIELD_STRING(field);
 	const char *hint = purple_request_field_get_type_hint(field);
 	GntWidget *entry = gnt_entry_new(
-			purple_request_field_string_get_default_value(field));
+			purple_request_field_string_get_default_value(strfield));
 	gnt_entry_set_masked(GNT_ENTRY(entry),
-			purple_request_field_string_is_masked(field));
+	                     purple_request_field_string_is_masked(strfield));
 	if (hint && g_str_has_prefix(hint, "screenname")) {
 		PurpleBlistNode *node = purple_blist_get_default_root();
 		gboolean offline = g_str_has_suffix(hint, "all");
@@ -659,7 +662,7 @@ finch_request_fields(const char *title, 
 
 			if (type == PURPLE_REQUEST_FIELD_BOOLEAN) {
 				widget = create_boolean_field(field);
-			} else if (type == PURPLE_REQUEST_FIELD_STRING) {
+			} else if(PURPLE_IS_REQUEST_FIELD_STRING(field)) {
 				widget = create_string_field(field, &username);
 			} else if (type == PURPLE_REQUEST_FIELD_INTEGER) {
 				widget = create_integer_field(field);
@@ -870,6 +873,10 @@ finch_request_save_in_prefs(G_GNUC_UNUSE
 			gpointer val = NULL;
 			const char *id = purple_request_field_get_id(field);
 
+			if(PURPLE_IS_REQUEST_FIELD_STRING(field)) {
+				PurpleRequestFieldString *sfield = PURPLE_REQUEST_FIELD_STRING(field);
+				val = (gpointer)purple_request_field_string_get_value(sfield);
+			} else {
 			switch (type) {
 				case PURPLE_REQUEST_FIELD_LIST:
 					val = purple_request_field_list_get_selected(field)->data;
@@ -881,12 +888,10 @@ finch_request_save_in_prefs(G_GNUC_UNUSE
 				case PURPLE_REQUEST_FIELD_INTEGER:
 					val = GINT_TO_POINTER(purple_request_field_int_get_value(field));
 					break;
-				case PURPLE_REQUEST_FIELD_STRING:
-					val = (gpointer)purple_request_field_string_get_value(field);
-					break;
 				default:
 					break;
 			}
+			}
 
 			pt = purple_prefs_get_pref_type(id);
 			switch (pt) {
@@ -917,16 +922,15 @@ finch_request_save_in_prefs(G_GNUC_UNUSE
 GntWidget *finch_request_field_get_widget(PurpleRequestField *field)
 {
 	GntWidget *ret = NULL;
-	if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
+	if(PURPLE_IS_REQUEST_FIELD_STRING(field)) {
+		ret = create_string_field(field, NULL);
+	} else if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
 		ret = create_account_field(field);
 	} else {
 	switch (purple_request_field_get_field_type(field)) {
 		case PURPLE_REQUEST_FIELD_BOOLEAN:
 			ret = create_boolean_field(field);
 			break;
-		case PURPLE_REQUEST_FIELD_STRING:
-			ret = create_string_field(field, NULL);
-			break;
 		case PURPLE_REQUEST_FIELD_INTEGER:
 			ret = create_integer_field(field);
 			break;
diff --git a/libpurple/account.c b/libpurple/account.c
--- a/libpurple/account.c
+++ b/libpurple/account.c
@@ -38,6 +38,7 @@
 #include "purpleprotocolmanager.h"
 #include "purpleprotocolserver.h"
 #include "request.h"
+#include "request/purplerequestfieldstring.h"
 #include "server.h"
 #include "signals.h"
 #include "util.h"
@@ -1077,7 +1078,8 @@ purple_account_request_password(PurpleAc
 	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("password", _("Enter Password"), NULL, FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
 
@@ -1114,7 +1116,8 @@ purple_account_request_change_password(P
 
 	field = purple_request_field_string_new("password", _("Original password"),
 										  NULL, FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	if (!protocol || !(purple_protocol_get_options(protocol) & OPT_PROTO_PASSWORD_OPTIONAL))
 		purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
@@ -1122,7 +1125,8 @@ purple_account_request_change_password(P
 	field = purple_request_field_string_new("new_password_1",
 										  _("New password"),
 										  NULL, FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	if (!protocol || !(purple_protocol_get_options(protocol) & OPT_PROTO_PASSWORD_OPTIONAL))
 		purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
@@ -1130,7 +1134,8 @@ purple_account_request_change_password(P
 	field = purple_request_field_string_new("new_password_2",
 										  _("New password (again)"),
 										  NULL, FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	if (!protocol || !(purple_protocol_get_options(protocol) & OPT_PROTO_PASSWORD_OPTIONAL))
 		purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -98,6 +98,7 @@ purple_coresources = [
 	'queuedoutputstream.c',
 	'request.c',
 	'request/purplerequestfieldaccount.c',
+	'request/purplerequestfieldstring.c',
 	'request-datasheet.c',
 	'roomlist.c',
 	'savedstatuses.c',
@@ -222,6 +223,7 @@ purple_coreheaders = [
 
 purple_request_headers = [
 	'request/purplerequestfieldaccount.h',
+	'request/purplerequestfieldstring.h',
 ]
 
 purple_generated_sources = []
diff --git a/libpurple/protocols/demo/purpledemoprotocolactions.c b/libpurple/protocols/demo/purpledemoprotocolactions.c
--- a/libpurple/protocols/demo/purpledemoprotocolactions.c
+++ b/libpurple/protocols/demo/purpledemoprotocolactions.c
@@ -490,7 +490,8 @@ purple_demo_protocol_request_fields_acti
 	field = purple_request_field_string_new("masked-string",
 	                                        _("A masked string"), _("default"),
 	                                        FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	purple_request_group_add_field(group, field);
 	field = purple_request_field_string_new("alphanumeric",
 	                                        _("An alphanumeric string"),
diff --git a/libpurple/protocols/gg/validator.c b/libpurple/protocols/gg/validator.c
--- a/libpurple/protocols/gg/validator.c
+++ b/libpurple/protocols/gg/validator.c
@@ -39,11 +39,9 @@ ggp_validator_password(PurpleRequestFiel
 {
 	const char *value;
 
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-	g_return_val_if_fail(purple_request_field_get_field_type(field) ==
-		PURPLE_REQUEST_FIELD_STRING, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD_STRING(field), FALSE);
 
-	value = purple_request_field_string_get_value(field);
+	value = purple_request_field_string_get_value(PURPLE_REQUEST_FIELD_STRING(field));
 
 	if (value != NULL) {
 		size_t len = strlen(value);
@@ -67,15 +65,11 @@ gboolean ggp_validator_password_equal(Pu
 	const char *value1, *value2;
 	PurpleRequestField *field2 = field2_p;
 
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field2), FALSE);
-	g_return_val_if_fail(purple_request_field_get_field_type(field) ==
-		PURPLE_REQUEST_FIELD_STRING, FALSE);
-	g_return_val_if_fail(purple_request_field_get_field_type(field2) ==
-		PURPLE_REQUEST_FIELD_STRING, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD_STRING(field), FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD_STRING(field2), FALSE);
 
-	value1 = purple_request_field_string_get_value(field);
-	value2 = purple_request_field_string_get_value(field2);
+	value1 = purple_request_field_string_get_value(PURPLE_REQUEST_FIELD_STRING(field));
+	value2 = purple_request_field_string_get_value(PURPLE_REQUEST_FIELD_STRING(field2));
 
 	if (g_strcmp0(value1, value2) == 0)
 		return TRUE;
diff --git a/libpurple/protocols/jabber/buddy.c b/libpurple/protocols/jabber/buddy.c
--- a/libpurple/protocols/jabber/buddy.c
+++ b/libpurple/protocols/jabber/buddy.c
@@ -557,7 +557,6 @@ jabber_set_buddy_icon(G_GNUC_UNUSED Purp
 static void
 jabber_format_info(PurpleConnection *gc, PurpleRequestPage *page) {
 	PurpleXmlNode *vc_node;
-	PurpleRequestField *field;
 	PurpleProtocol *protocol = NULL;
 	const char *text;
 	char *p;
@@ -573,11 +572,9 @@ jabber_format_info(PurpleConnection *gc,
 		if (*vc_tp->label == '\0')
 			continue;
 
-		field = purple_request_page_get_field(page, vc_tp->tag);
-		text  = purple_request_field_string_get_value(field);
+		text = purple_request_page_get_string(page, vc_tp->tag);
 
-
-		if (text != NULL && *text != '\0') {
+		if(!purple_strempty(text)) {
 			PurpleXmlNode *xp;
 
 			purple_debug_info("jabber", "Setting %s to '%s'\n", vc_tp->tag, text);
diff --git a/libpurple/protocols/jabber/jabber.c b/libpurple/protocols/jabber/jabber.c
--- a/libpurple/protocols/jabber/jabber.c
+++ b/libpurple/protocols/jabber/jabber.c
@@ -1923,13 +1923,15 @@ jabber_password_change(G_GNUC_UNUSED GSi
 
 	field = purple_request_field_string_new("password1", _("Password"),
 			"", FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
 
 	field = purple_request_field_string_new("password2", _("Password (again)"),
 			"", FALSE);
-	purple_request_field_string_set_masked(field, TRUE);
+	purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+	                                       TRUE);
 	purple_request_field_set_required(field, TRUE);
 	purple_request_group_add_field(group, field);
 
diff --git a/libpurple/protocols/jabber/xdata.c b/libpurple/protocols/jabber/xdata.c
--- a/libpurple/protocols/jabber/xdata.c
+++ b/libpurple/protocols/jabber/xdata.c
@@ -84,7 +84,8 @@ jabber_x_data_ok_cb(struct jabber_x_data
 				case JABBER_X_DATA_TEXT_SINGLE:
 				case JABBER_X_DATA_JID_SINGLE:
 					{
-					const char *value = purple_request_field_string_get_value(field);
+					PurpleRequestFieldString *sfield = PURPLE_REQUEST_FIELD_STRING(field);
+					const char *value = purple_request_field_string_get_value(sfield);
 					if (value == NULL)
 						break;
 					fieldnode = purple_xmlnode_new_child(result, "field");
@@ -95,8 +96,9 @@ jabber_x_data_ok_cb(struct jabber_x_data
 					}
 				case JABBER_X_DATA_TEXT_MULTI:
 					{
+					PurpleRequestFieldString *sfield = PURPLE_REQUEST_FIELD_STRING(field);
+					const char *value = purple_request_field_string_get_value(sfield);
 					char **pieces, **p;
-					const char *value = purple_request_field_string_get_value(field);
 					if (value == NULL)
 						break;
 					fieldnode = purple_xmlnode_new_child(result, "field");
@@ -230,7 +232,8 @@ void *jabber_x_data_request_with_actions
 
 			field = purple_request_field_string_new(var, label,
 					value ? value : "", FALSE);
-			purple_request_field_string_set_masked(field, TRUE);
+			purple_request_field_string_set_masked(PURPLE_REQUEST_FIELD_STRING(field),
+			                                       TRUE);
 			purple_request_group_add_field(group, field);
 
 			g_hash_table_replace(data->fields, g_strdup(var), GINT_TO_POINTER(JABBER_X_DATA_TEXT_SINGLE));
diff --git a/libpurple/purplechatconversation.c b/libpurple/purplechatconversation.c
--- a/libpurple/purplechatconversation.c
+++ b/libpurple/purplechatconversation.c
@@ -29,6 +29,7 @@
 #include "purpleenums.h"
 #include "purpleprivate.h"
 #include "request.h"
+#include "request/purplerequestfieldstring.h"
 #include "server.h"
 
 typedef struct {
diff --git a/libpurple/purplerequestfield.h b/libpurple/purplerequestfield.h
--- a/libpurple/purplerequestfield.h
+++ b/libpurple/purplerequestfield.h
@@ -64,7 +64,6 @@ struct _PurpleRequestFieldClass {
 /**
  * PurpleRequestFieldType:
  * @PURPLE_REQUEST_FIELD_NONE: No field.
- * @PURPLE_REQUEST_FIELD_STRING: String field.
  * @PURPLE_REQUEST_FIELD_INTEGER: Integer field.
  * @PURPLE_REQUEST_FIELD_BOOLEAN: Boolean field.
  * @PURPLE_REQUEST_FIELD_CHOICE: Choice field (dropdown?).
@@ -78,7 +77,6 @@ struct _PurpleRequestFieldClass {
 typedef enum
 {
 	PURPLE_REQUEST_FIELD_NONE,
-	PURPLE_REQUEST_FIELD_STRING,
 	PURPLE_REQUEST_FIELD_INTEGER,
 	PURPLE_REQUEST_FIELD_BOOLEAN,
 	PURPLE_REQUEST_FIELD_CHOICE,
@@ -319,97 +317,6 @@ void purple_request_field_set_sensitive(
 gboolean purple_request_field_is_sensitive(PurpleRequestField *field);
 
 /**************************************************************************/
-/* String Field API                                                       */
-/**************************************************************************/
-
-/**
- * purple_request_field_string_new:
- * @id:            The field ID.
- * @text:          The text label of the field.
- * @default_value: The optional default value.
- * @multiline:     Whether or not this should be a multiline string.
- *
- * Creates a string request field.
- *
- * Returns: (transfer full): The new field.
- */
-PurpleRequestField *purple_request_field_string_new(const char *id,
-												const char *text,
-												const char *default_value,
-												gboolean multiline);
-
-/**
- * purple_request_field_string_set_default_value:
- * @field:         The field.
- * @default_value: The default value.
- *
- * Sets the default value in a string field.
- */
-void purple_request_field_string_set_default_value(PurpleRequestField *field,
-												 const char *default_value);
-
-/**
- * purple_request_field_string_set_value:
- * @field: The field.
- * @value: The value.
- *
- * Sets the value in a string field.
- */
-void purple_request_field_string_set_value(PurpleRequestField *field,
-										 const char *value);
-
-/**
- * purple_request_field_string_set_masked:
- * @field:  The field.
- * @masked: The masked value.
- *
- * Sets whether or not a string field is masked
- * (commonly used for password fields).
- */
-void purple_request_field_string_set_masked(PurpleRequestField *field,
-										  gboolean masked);
-
-/**
- * purple_request_field_string_get_default_value:
- * @field: The field.
- *
- * Returns the default value in a string field.
- *
- * Returns: The default value.
- */
-const char *purple_request_field_string_get_default_value(PurpleRequestField *field);
-
-/**
- * purple_request_field_string_get_value:
- * @field: The field.
- *
- * Returns the user-entered value in a string field.
- *
- * Returns: The value.
- */
-const char *purple_request_field_string_get_value(PurpleRequestField *field);
-
-/**
- * purple_request_field_string_is_multiline:
- * @field: The field.
- *
- * Returns whether or not a string field is multi-line.
- *
- * Returns: %TRUE if the field is mulit-line, or %FALSE otherwise.
- */
-gboolean purple_request_field_string_is_multiline(PurpleRequestField *field);
-
-/**
- * purple_request_field_string_is_masked:
- * @field: The field.
- *
- * Returns whether or not a string field is masked.
- *
- * Returns: %TRUE if the field is masked, or %FALSE otherwise.
- */
-gboolean purple_request_field_string_is_masked(PurpleRequestField *field);
-
-/**************************************************************************/
 /* Integer Field API                                                      */
 /**************************************************************************/
 
